import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

// use `self` instead of `window`, account for non-window contexts, such as in Web Workers
// @see https://developer.mozilla.org/en-US/docs/Web/API/Window/self
export var supportsTouchEvents = ('ontouchstart' in self);
export var supportsPointerEvents = !!self.PointerEvent;
export function isTouchEvent(event) {
  return supportsTouchEvents && event instanceof TouchEvent;
}
export function isMouseEvent(event) {
  return !self.MouseEvent || event instanceof MouseEvent && (!supportsPointerEvents || !(event instanceof self.PointerEvent));
}
/**
 * borrow from pixi/interaction
 * Ensures that the original event object contains all data that a regular pointer event would have
 */

export function normalizeToPointerEvent(event) {
  if (isTouchEvent(event)) {
    // for (let i = 0; i < event.changedTouches.length; i++) {
    var touch = event.changedTouches[0]; // @ts-ignore

    return _objectSpread({
      button: event.touches.length ? 1 : 0,
      buttons: event.touches.length ? 1 : 0,
      isPrimary: event.touches.length === 1 && event.type === 'touchstart',
      width: touch.radiusX || 1,
      height: touch.radiusY || 1,
      tiltX: 0,
      tiltY: 0,
      pointerType: 'touch',
      pointerId: touch.identifier || 0,
      pressure: touch.force || 0.5,
      twist: 0,
      tangentialPressure: 0,
      offsetX: touch.clientX,
      offsetY: touch.clientY
    }, touch); // }
  } else if (isMouseEvent(event)) {
    // @ts-ignore
    return _objectSpread({
      isPrimary: true,
      width: 1,
      height: 1,
      tiltX: 0,
      tiltY: 0,
      pointerType: 'mouse',
      pointerId: 10,
      pressure: 0.5,
      twist: 0,
      tangentialPressure: 0
    }, event);
  } else {
    return event;
  }
}
//# sourceMappingURL=index.js.map